
#include "Creature.h"

#include "Sensor.h"

Creature::Creature()
{

	tex = new Texture("data/squid.png", IMAGE_PNG);

	model = 0;	

	initialized = false;
}

void Creature::initialize()
{

	cGeometry = glGenLists(1);

	glNewList(cGeometry, GL_COMPILE);
	
	
	
	
	float creatureSize = 0.2;

	
	glBegin(GL_POLYGON);
	
	glTexCoord2f(0.0, 0.0);
	glVertex2f(-creatureSize, -creatureSize);
	glTexCoord2f(1.0, 0.0);
	glVertex2f(creatureSize, -creatureSize);
	glTexCoord2f(1.0, 1.0);
	glVertex2f(creatureSize, creatureSize);
	glTexCoord2f(0.0, 1.0);
	glVertex2f(-creatureSize, creatureSize);
	
	glEnd();
	
	
	glEndList();
	
	
	model = obj_add_file("data/cube.obj");
	
	initialized = true;

}

int Creature::cull()
{
	if(!initialized)
		initialize();

	draw();
	
	
	return 1;
}
	
void Creature::draw()
{


	//obj_draw_file(model);
	

	if(tex && !tex->isLoaded())
	{
		
		tex->load();
	
	}
	
	
	
	
	glColor4f(1.0, 1.0, 1.0, 0.5);
	
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);	
	
	
	if(tex)
	{
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, *(tex->getId()));
			
	}
	
	glCallList(cGeometry);

	if(tex)
	{
		glBindTexture(GL_TEXTURE_2D, 0);
		glDisable(GL_TEXTURE_2D);
	}
	
	
	
	// draw tentacles

	glLineWidth(4.0);	
	glBegin(GL_LINES);

	
	for(int i = 0; i < sensorList->size(); i++)
	{
	
		Sensor *thisSensor = reinterpret_cast<Sensor*>((*sensorList)[i]);
	
		glVertex2f(0.0, 0.0);
		glVertex2f(thisSensor->pos.x - pos.x, thisSensor->pos.y - pos.y);
		//printf("%f %f\n", thisSensor->pos.x, thisSensor->pos.y);
	}

	
	glEnd();
	
	glLineWidth(1.0);

	glDisable(GL_BLEND);

	
}

RTTI_NODE_TYPE Creature::getType() const
{

	return RTTI_USER2;
}


void Creature::doupdate()
{

	pos.x = glTransform()[12];
	pos.y = glTransform()[13];
	pos.z = glTransform()[14];

	// position is average of positions of the tentacles
	
	int numsensors = sensorList->size();
	Vec3 _pos;
	
	
	for(int i = 0; i < numsensors; i++)
	{
		
		Sensor *thisSensor = reinterpret_cast<Sensor*>((*sensorList)[i]);
		
		_pos = _pos + thisSensor->pos;
	}
	
	_pos = _pos / numsensors;

	Vec3 current(pos.x, pos.y, 0.0);
	vel = _pos - current;

	vel = vel * 0.1;
	
	translate(vel.x, vel.y, 0.0);


	
	
	
}
