
#ifndef Creature_H
#define Creature_H


#include "../../src-core/Node.h"

#include "../../src-core/ObjAPI.h"

class Creature: public Node
{

public:
	Creature();


	virtual int cull();
	virtual void draw();
	virtual RTTI_NODE_TYPE getType() const;
	virtual void doupdate();
	
	virtual void drawBBox() { }
	virtual void userEvent(UserEvent*) { }
	virtual void addTexture(Texture*) { }
	virtual Texture* getTexture() { }
	virtual void computeBBox() { }
	virtual BBox* getBBox() { }
	virtual void addGeometry(Geometry*) { }
	virtual Geometry* getGeometry() { }
	virtual void print() { }
	

	
	void initialize();
	
	
	Vec3 pos, vel;
	
	
	std::vector<Node*>* sensorList;
	
private:

	int model;

	bool initialized;

	GLuint cGeometry;
	Texture *tex;

};


#endif