
#include "MoCap.h"



int MoCap::read(const char* filename)
{


	FILE* file = fopen(filename, "r");
	
	char linebuffer[32];
	
	fscanf(file, "%s\n", linebuffer);
    if(strcmp(linebuffer, "MOCAP"))
    {
        printf("No MOCAP specified!\n");
        exit(0);
    }

    int nofsensor;
    int noffile;
    
    fscanf(file, "%d %d\n", &noffile, &nofsensor);

    printf("%d mocap datafile, picking %d sensors only.\n",
           noffile, nofsensor);

	
	
	
    for(int i = 0; i < noffile; i++)
    {
        fscanf(file, "%s\n", &linebuffer);
        printf("Loading mocap file %d, %s\n", i, linebuffer);

        FILE* data_file = fopen(linebuffer, "r");
		if(data_file == NULL)
		{
			printf("Couldn't read file.\n");
			exit(0);	
		}
     
        
        for(int j=0; j<nofsensor; j++)
        {
            SensorData *sd = new SensorData();
           	sensorDataList.push_back(sd);
           
        }
	

       
       
        
        
        
        int linecount = 0;
        char buf[32];
        
        while( !feof(data_file)  )
        {
        
        	float timestep;
        	
        
			float value;
			
			fscanf(data_file, "%s\n", &buf);
			
			// timestep 
			value = atof(buf);
			timestep = value;
			//printf("timestep: %f    ", timestep);
			
			float values[6];
			
			for(int k = 0; k < 3; k++)
			{
			
				Vec3 *pos = new Vec3();
        		Vec3 *ori = new Vec3();
			
				fscanf(data_file, "%s\n", &buf);
				// x
				value = atof(buf);
				values[0] = value;
				
				fscanf(data_file, "%s\n", &buf);
				// y
				value = atof(buf);
				values[1] = value;
				
				fscanf(data_file, "%s\n", &buf);
				// z
				value = atof(buf);
				values[2] = value;
				
				fscanf(data_file, "%s\n", &buf);
				// ori x
				value = atof(buf);
				values[3] = value;
				
				fscanf(data_file, "%s\n", &buf);
				// ori y
				value = atof(buf);
				values[4] = value;
				
				fscanf(data_file, "%s\n", &buf);
				// ori z
				value = atof(buf);
				values[5] = value;
				
				
				
			
				
				pos->set(values[0], values[1], values[2]);
				ori->set(values[3], values[4], values[5]);
				
				
				int sensorIndex = (i * nofsensor) + k;
				
				
				
				//printf("[%i]  %f %f %f ", sensorIndex, values[0], values[1], values[2]);
				
				sensorDataList[sensorIndex]->timestep.push_back(timestep);
				sensorDataList[sensorIndex]->pos.push_back(pos);
				sensorDataList[sensorIndex]->ori.push_back(ori);
			}
		
			{ // unused sensor
				for(int k = 0; k < 6; k++)
				{
					fscanf(data_file, "%s\n", &buf);
				}
			}
			
			
			//printf("%s\n", buf);
			//printf("\n");
			
			linecount++;
		}
        
        
        
        printf("File %s has %d lines.\n", linebuffer, linecount);
       

        fclose(data_file);
    }



	fclose(file);
	
	
	
	step = 0;
	
	
	// RATKO
	// figure out the total number of steps we will use for animation
	// this will be the smallest of all the sensorData lists
	int s;
	numSteps = sensorDataList[0]->pos.size();  
	for(s=1; s < sensorDataList.size(); s++)
		numSteps = MIN(numSteps, sensorDataList[s]->pos.size());
	//printf("\n\nsize of sensorDataList = %d\n\n", numSteps);
		
	
	return 1;

}
