
#ifndef MoCap_H
#define MoCap_H



#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <vector>

#include "../../src-math/Vector.h"


#include "../../src-sound/OggSound.h"  // RATKO
#include "../../src-core/Math.h"   // RATKO

struct SensorData
{

	std::vector<Vec3*> pos;
	std::vector<Vec3*> ori;
	std::vector<float> timestep;
};


class MoCap
{

public:

	std::vector<SensorData*> sensorDataList;
	OggSound *sound;   //sound data   // RATKO
	
	int read(const char* filename);


	int step;
	

	// RATKO
	// total number of steps in the datasets
	// (actually this is the smallest set of 
	// all of the ones we've read in)
	int numSteps; 
};


#endif

