
#include "Sensor.h"

#include <math.h>


const float DEG2RAD = 3.14159/180;




SensorRep::SensorRep()
{

	initialized = false;
	
	

	

	degree = 0;
	


}

int SensorRep::cull()
{
	if(!initialized)
		initialize();

	draw();
	
	
	return 1;


}


void SensorRep::initialize()
{

	
	sensorGeom = glGenLists(1);

	glNewList(sensorGeom, GL_COMPILE);	
	
	float creatureSize = 0.01;

	glBegin(GL_POLYGON);
	
	glTexCoord2f(0.0, 0.0);
	glVertex2f(-creatureSize, -creatureSize);
	glTexCoord2f(1.0, 0.0);
	glVertex2f(creatureSize, -creatureSize);
	glTexCoord2f(1.0, 1.0);
	glVertex2f(creatureSize, creatureSize);
	glTexCoord2f(0.0, 1.0);
	glVertex2f(-creatureSize, creatureSize);
	
	glEnd();
	
	glEndList();
	
	
	
	
	// julian
	genBaseAnim();
	
	int init = rand();
    pre_angle = init - (init/360.0f)*360.0f;
	
	
	
	
	

	initialized = true;
}

void SensorRep::draw()
{

	//glColor4f(1.0, 0.2, 0.0, 0.3);


	
	
	glColor4f(0.5, 0.5, 1.0, 0.5);
	
	
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);	

	int idx = counter % baseAnimFrames;
	
	glPushMatrix();
	glScalef(0.3, 0.3, 0.3);
	glCallList(baseAnim[idx]);
	glPopMatrix(); 
	
	 
	counter++;
    counter = counter % baseAnimFrames;
    
    
    glDisable(GL_BLEND);

	

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);	
	
	
	

	//glCallList(sensorGeom);
	
	
	if(tentacle.size() != 16) return;
	
	glLineWidth(2.0f);

	
	glBegin(GL_LINE_STRIP);
	
	std::list<Vertex*>::iterator i;
	std::list<float>::iterator i_fc;
	std::list<float>::iterator i_fs;
	
	float index = 0;
	float effectprop = 1;
	float curve_eff = 0.0;
	
	float y_INCR = 0.005 + ( 0.05 * vel->y );
	
	
	i = tentacle.begin();
	i_fc = cos_curve.begin();
	
	for(; i != tentacle.end(); i++)
	{
	
		glVertex2f(curve_eff * (*i_fc) + 
			(effectprop * (*i)->x), (effectprop * (*i)->y) - index);
		
		index += y_INCR;
		effectprop *= 1.05;
		curve_eff += 0.1;
		
		i_fc++;
	}
	
	glEnd();
	
	
	
	glBegin(GL_LINE_STRIP);
	
	index = 0;
	effectprop = 1;
	curve_eff = 0.0;
	
	i = tentacle.begin();
	i_fs = sin_curve.begin();
	
	for(; i != tentacle.end(); i++)
	{
	
		glVertex2f(curve_eff * (*i_fs) +
			0.025 + (effectprop * (*i)->x), (effectprop * (*i)->y) - index);
		
		index += y_INCR;
		effectprop *= 1.05;
		curve_eff += 0.1;
		
		i_fs++;
	}
	
	glEnd();


	glBegin(GL_LINE_STRIP);
	
	index = 0;
	effectprop = 1;
	curve_eff = 0.0;
	
	i = tentacle.begin();
	i_fs = sin_curve.begin();

	for(; i != tentacle.end(); i++)
	{
	
		glVertex2f(curve_eff * (*i_fs) +
			-0.025 + (effectprop * (*i)->x), (effectprop * (*i)->y) - index);
		
		index += y_INCR;
		effectprop *= 1.05;
		curve_eff += 0.1;
		
		i_fs++;
	}
	
	glEnd();


	
	glLineWidth(1.0f);
	
	
	
	
	glDisableClientState(GL_VERTEX_ARRAY);

	
	glDisable(GL_BLEND);
}


void SensorRep::doupdate()
{

	
	// curvature math
	
	float deg = degree * DEG2RAD;
	
	
	//printf("%i, %f\n", degree, cos(deg));
	
	if(tentacle.size() == 16)
	{
	
		Vertex *v = tentacle.back();
		tentacle.pop_back();
		delete v;
		
		
		cos_curve.pop_back();
		sin_curve.pop_back();
	}
	
	
	Vertex *v = new Vertex();
	
	v->x = - 0.1 * vel->x;
	v->y = - 0.1 * vel->y;
	
	
	tentacle.push_front(v);
	cos_curve.push_front(cos(deg) * 0.025);
	sin_curve.push_front(sin(deg) * 0.025);
	
	
	
	// this should be based on magnitude of velocity
	if(vel->y > 0)
		degree += 2000.0 * sqrt( 0.5*vel->x*vel->x + vel->y*vel->y);
	else
		degree += 1;	
	
	if(degree >= 360)
		degree = 0;
		
	
	
	
}


RTTI_NODE_TYPE SensorRep::getType() const
{

	return RTTI_USER1;

}



Sensor::Sensor()
{

	pos.set(glTransform()[12], glTransform()[13], 0.0);
	vel.set(float(rrand(100)-50)/ 10000.0, float(rrand(100)-50)/ 10000.0, 0.0);
	orientation.set(0.0, 1.0, 0.0);

	initialized = false;
	
 
 
 	rep = new SensorRep();
 	
 	rep->pos = &pos;
 	rep->vel = &vel;
 	
 	attachChild(rep);


	tilt[0] = -35;
	tilt[1] = 35;
	
	current_tilt = 0;
	 	
}








//------------------------------------------------------------

// TODO
void SensorRep::genBaseAnim()
{
    int range = 240; // FIXME
    baseAnimFrames = range;

    printf("-- Generate %d frames of base animation.\n", baseAnimFrames);

    baseAnim = new GLuint[range];
    int n = glGenLists(range);

    float unitAngle = 360.0f/range;    

    for(int i=0; i<range; i++) // i <- time step
    {
	baseAnim[i] = n + i;

	glNewList(baseAnim[i], GL_COMPILE);
	{
	    // Mesh vertices loop: jellyfish code port
            
            int rez = 16;

            glPushMatrix();
            {
                
                int _t = rand() % 10;
                float t_angle = (float) _t;
                float sign = 1.0;
                
                for( int w = 0; w < 6; w++ )
                {
                    float nn = w * 0.2;
                    float degInRad = (i*unitAngle) * DEG2RAD;
                    float x_scale = fabs(sin(degInRad)) + 1.0f;
                    float y_scale = fabs(cos(degInRad)) + 1.5f;

                    float tscale = 1.0f/(1+10*nn);
                    // glScalef(0.15*x_scale, 0.07, 0.15*y_scale);


                    glPushMatrix();
                    {

                    glTranslatef(0.0, -nn * 0.3, 0.0);

                    /*
                    if(w != 0) {
                    
                        glRotatef(3*t_angle, 0, 0, 1);
                        t_angle = t_angle + sign * 4.0f;
                        
                        if(t_angle > 10.0f) 
                        {
                            sign = -1.0f;
                            t_angle = 10.0f; 
                        }
                        else if(t_angle < -10.0f) {
                            sign = 1.0f;
                            t_angle = -10.0f;
                        }
                        else
                            ;
                    }
                    */


                    glScalef(0.1 * 1.5 * x_scale * tscale, 
                             0.1 * 0.3 * y_scale * tscale * (10*nn+1), 
                             0.1 * tscale * nn);

   	            for(int j=1; j < rez; j++)
	            {
	                for(int k=0; k < rez; k++)
		        {
                            Vec3 p  = get_p(j, k);
                            Vec3 p0 = get_mod_p(p.x, p.y, p.z, i);
                            // p0 = p;
  
                            p = get_p(j, k+1);
                            Vec3 p1 = get_mod_p(p.x, p.y, p.z, i);
                            // p1 = p;

                            p = get_p(j-1, k+1);
                            Vec3 p2 = get_mod_p(p.x, p.y, p.z, i);
                            // p2 = p;

                            p = get_p(j-1, k);
                            Vec3 p3 = get_mod_p(p.x, p.y, p.z, i);
                            // p3 = p;

                            // glBegin(GL_LINE_LOOP);
                            glBegin(GL_POLYGON);
                            {

                                glTexCoord2f(0.0, 0.0);
                                glVertex3f(p0.x, p0.y, p0.z);
                                glTexCoord2f(1.0, 0.0);
                                glVertex3f(p1.x, p1.y, p1.z);
                                glTexCoord2f(1.0, 1.0);
                                glVertex3f(p2.x, p2.y, p2.z);
                                glTexCoord2f(0.0, 1.0);
                                glVertex3f(p3.x, p3.y, p3.z);
                            }
                            glEnd();
	                } // for-k
	            }  // for-j
                    }
                    glPopMatrix();

                } // for-n
            }
            glPopMatrix();
            
            //------------ End of port -------------
	}
	glEndList();
    }

    counter = rand() % range;
}

Vec3 SensorRep::get_p(int j, int k)
{
    int   rez = 16;
    float   r = 1.0f;

    float unitTheta  = 180.0f/rez;
    float unitPhi    = 360.0f/rez;

    float theta = j * unitTheta * DEG2RAD;
    float phi   = k * unitPhi   * DEG2RAD;

    // notice: switch y and z, since we want to show the hemi-sphere
    //         in X-Y plane
    float x = r * sin(theta) * cos(phi);
    float y = r * cos(theta);
    float z = r * sin(theta) * sin(phi);;

    return Vec3(x, y, z);
}

Vec3 SensorRep::get_mod_p(float x, float y, float z, int frame)
{
    // TODO FIXME
    float jellyparam = frame;
    jellyparam = jellyparam - (jellyparam/360.0f) * 360.0f;

    float angle = jellyparam * DEG2RAD;
    float spd = 1.5 + 0.5 * sin(angle) * frame;

    jellyparam = jellyparam + spd;

    float w1 = 360.0f/frame + 1.40*frame;
    float w2 = 360.0f/frame + 2.16*frame;
    float w3 = 360.0f/frame + 0.79*frame;

    jellyparam = jellyparam - (jellyparam/360.0f)*360.0f;
    w1 = w1 - (w1/360.0f)*360.0f;
    w2 = w2 - (w2/360.0f)*360.0f;
    w3 = w3 - (w3/360.0f)*360.0f;

    float h1 = 590.0f * (y + x);
    float h2 = 190.0f * (y + z);

    float wz = 0.08f * cos(w1+h1) * cos(w2+h1) * cos(w3+h1) * y;
    float wx = 0.08f * sin(w1+h2) * cos(w2+h2) * cos(w3+h2) * y;

    float s  = sqrt(x*x + y*y);
    float n  = 0.5 * cos(jellyparam)/(fabs(y)+0.3) + s;

    float c;
    if(y < 0) 
    {
	c = 0.1 * fabs(y) * fabs(y);
    }
    else
    {
	c = 0;
    }

    angle = (-jellyparam+140*y) * DEG2RAD;
    float n2 = 0.3 * (2.5 + sin(angle)) / (fabs(y)+1.3);

    x = x * (n2+c) + wx;
    y = y * (n+1.4f) * 0.4f;
    z = z * (n2+c) + wz;

    return Vec3(x, y, z);
}
//------------------------------------------------------------





int Sensor::cull()
{

	if(!initialized)
		initialize();

	draw();
	
	return 1;

}

void Sensor::initialize()
{

	

		
	initialized = true;
}


void Sensor::draw()
{
	
	
}


RTTI_NODE_TYPE Sensor::getType() const
{

	return RTTI_USER1;
}
	
	
void Sensor::doupdate()
{
	if(mocap->step >= mocap->sensorDataList[sensorId]->pos.size())
		exit(1);

	Vec3 *vec = mocap->sensorDataList[sensorId]->pos[mocap->step];

	*vec = *vec * 0.45;
	
	
	glTransform()[12] = mocap->sensorDataList[sensorId]->pos[mocap->step]->x;
	glTransform()[13] = mocap->sensorDataList[sensorId]->pos[mocap->step]->y;
	glTransform()[14] = 0.0;


	
	if(sensorId == 0)
	{
		glTransform()[12] += 0.05;
	}
	if(sensorId == 2)
	{
		glTransform()[12] -= 0.05;
	}
	
	glTransform()[13] += -0.1;
	glTransform()[12] += 0.55;

	
	
	

	pos.x = glTransform()[12];
	pos.y = glTransform()[13];
	pos.z = glTransform()[14];
	
	
	vel.x = pos.x - pos_old.x;
	vel.y = pos.y - pos_old.y;
	vel.z = 0.0;
	
	
	//printf("%f %f\n", vel.x, vel.y);
	
	pos_old.x = pos.x;
	pos_old.y = pos.y;
	pos_old.z = pos.z;
		
	
	if(vel.x != 0)
	{
	
		if(vel.x < 0)
		{
			
			if(current_tilt <= tilt[1])
			{
			
				rep->rotate(0, 0, 1, 5);
				current_tilt+= 5;
			}
		}
		else
		{
			
			if(current_tilt >= tilt[0])
			{
			
				rep->rotate(0, 0, 1, -5);
				current_tilt-= 5;
			}
		}
	}
		
	//printf("current tilt: %f\n", current_tilt);
	
	// Code to align the jellyfish
	
	/*
	Vec3 original(orientation.x, orientation.y, orientation.z);	
	Vec3 target(vel.x, ABS(vel.y), vel.z);
	
	original.normalize();
	target.normalize();
	
	float angle2rotate = Vec3::AngleBetween(original, target);
	

	
	Vec3 T = target - original;
	
	Vec3 N = Vec3::CrossProduct(T, target);
	if(ToDegree(angle2rotate) >= -180 && ToDegree(angle2rotate) <= 180)
	{
	
		float angle = ToDegree(angle2rotate);
		
		if(N.z <= 0)
		{
		
			//Matrix::rotation(glTransform(), 0, 0, 1, angle);
			rep->rotate(0, 0, 1, angle);
			//orientation.rotate(angle);
			
		}
		
		else
		{
			//Matrix::rotation(glTransform(), 0, 0, 1, angle);
			rep->rotate(0, 0, 1, -angle);
			//orientation.rotate(-angle);
		}
	}
	
	
	
	orientation.x = vel.x;
	orientation.y = vel.y;
	orientation.z = vel.z;
	
	*/
	
	
	
	
	
	
	//printf("%i,  %f %f\n", mocap->step, pos.x, pos.y);

	/*
	
	if(pos.x + vel.x*0.01<= 0.01) {
	   vel.x -= 2.0f*vel.x;
	   
	}
	if(pos.x + vel.x*0.01>= 0.99) {
	   vel.x -= 2.0f*vel.x;
	   
	}
	if(pos.y + vel.y*0.01<= 0.01) {
	   vel.y -= 2.0f*vel.y;
	
	}
	if(pos.y + vel.y*0.01>= 0.99) {
	   vel.y -= 2.0f*vel.y;
	   
	}

	translate(vel.x, vel.y, 0.0);
	*/
}








