
#ifndef Sensor_H
#define Sensor_H


#include "../../src-core/Node.h"
#include "MoCap.h"


// 2d vertex

struct Vertex
{


	float x, y;

};

class SensorRep: public Node
{

public:

	SensorRep();


	virtual int cull();
	virtual void draw();
	virtual RTTI_NODE_TYPE getType() const;
	
	virtual void doupdate();
	
	
	
	virtual void drawBBox() { }
	virtual void userEvent(UserEvent*) { }
	virtual void addTexture(Texture*) { }
	virtual Texture* getTexture() { }
	virtual void computeBBox() { }
	virtual BBox* getBBox() { }
	virtual void addGeometry(Geometry*) { }
	virtual Geometry* getGeometry() { }
	virtual void print() { }
	

	
	void initialize();
	
	
	Vec3* pos;
	Vec3* vel;
	

private:

	GLuint sensorGeom;
	
	bool initialized;
		
	float degree;

	
	std::list<Vertex*> tentacle;
	std::list<float> cos_curve;
	std::list<float> sin_curve;
	
	
	// julian
        void genBaseAnim();
        void drawBase(int i);
        Vec3 get_p(int j, int k);
        Vec3 get_mod_p(float x, float y, float z, int i);

        int baseAnimFrames;
        int counter;
        GLuint * baseAnim;
        
        float pre_angle;
        
        
       	void dobody();
	
	
};

class Sensor: public Node
{

public:
	Sensor();


	virtual int cull();
	virtual void draw();
	virtual RTTI_NODE_TYPE getType() const;
	virtual void doupdate();
	
	virtual void drawBBox() { }
	virtual void userEvent(UserEvent*) { }
	virtual void addTexture(Texture*) { }
	virtual Texture* getTexture() { }
	virtual void computeBBox() { }
	virtual BBox* getBBox() { }
	virtual void addGeometry(Geometry*) { }
	virtual Geometry* getGeometry() { }
	virtual void print() { }
	

	
	void initialize();
	
	
	Vec3 pos, pos_old, vel;
	Vec3 orientation;
	
	MoCap *mocap;
	int sensorId;
		
private:


	float tilt[2];
	float current_tilt;

	
	
	bool initialized;

	SensorRep *rep;
	
	
	
		 
	

};




#endif