#include <stdlib.h>
#include <stdio.h>
#include <ctime>


#include "../../src-core/OpenGL.h"
#include "../../src-core/AppManager.h"
#include "../../src-core/PivotNode.h"
#include "../../src-core/RootNode.h"
#include "../../src-core/SceneGraph.h"
#include "../../src-sound/OggSound.h"


#include "Environment.h"




freetype::font_data our_font;

void drawCallback(Window* w)
{
	/*
	freetype::print(1, our_font, 220, 10,
		 "boids  drawn: %i  updated: %i", 
		
		 	*(w->getRender()->getSG()->getpdrawn()),
		 	*(w->getRender()->getSG()->getpupdated()));
	*/
}



int main(int argc, char** argv)
{

	srand(time(0));

	OggSound::initAL(&argc, argv);
	
	
	
	

	
	SceneGraph mysg;
	
	RootNode *root = new RootNode();
	root->setName("root");
	PivotNode *pivot = new PivotNode();
	pivot->setName("pivot");
	
	
	// RATKO
	OggSound *sound = new OggSound();    //moved up here and passed into Environment constructor
	printf("loading ogg file...\n");
	sound->load("sound/magpie_ratko.ogg");
	printf("done.\n");
	
	//Environment *env = new Environment();
	Environment *env = new Environment(sound);  // RATKO
	env->scale(1.2, 1.2, 1.0);
	env->translate(-0.5, -0.5, 0.0);
	env->setName("water");
	
	
	root->attachChild(pivot);
	pivot->attachChild(env);
	
	
	mysg.setRootNode(root);
	mysg.setPivotNode(pivot);
	
	
	
	
		
	AppManager *manager = new AppManager();
	
	Window* w0 = new Window(1, 0, 0, 768, 768, "opengl - mocapboids");
	w0->getRender()->getCamera()->setProjType(PERSPECTIVE);
	w0->setOffset(0, 0);
	w0->border(1);
	w0->end();
	w0->setFont(&our_font);
	w0->setDrawCallback(drawCallback);
	w0->getRender()->setSG(&mysg);
	

	
	manager->addWindow(w0);
	manager->addTimeouts(24.0f, 64.0f);

	
	/*
	OggSound *sound = new OggSound();
	printf("loading ogg file...\n");
	sound->load("sound/magpie1.ogg");
	printf("done.\n");
	*/
	
	sound->play();
	
	
	
	while(w0->shown())
		Fl::wait();
	
	
	delete sound;
	
	OggSound::exitAL();
	
	return 0;


}