
#include "AppManager.h"


float tm_idle;
float tm_draw;

void timerIdle(void *pData) {
	
	if( pData != NULL ) {
	
		Window *w = reinterpret_cast<Window*>(pData);
	
		w->idle();
	}
	
	Fl::repeat_timeout(1.0/tm_idle, timerIdle, pData);
}

void timerRedraw(void *pData)
{
	if( pData != NULL )
	{
		Window *w = reinterpret_cast<Window*>(pData);
	
		w->redraw();
	}
	
	Fl::repeat_timeout(1.0/tm_draw, timerRedraw, pData);
}

std::vector<Window*>* AppManager::getWindowList()
{

	return &windowList;
}

void AppManager::addWindow(Window* w)
{
	windowList.push_back(w);
	
}

void AppManager::addTimeouts(float idl, float drw)
{
	for(int i = 0; i < windowList.size(); i++)
	{
		windowList[i]->show();
		
		tm_draw = drw;
		tm_idle = idl;
		
		Fl::add_timeout(0.0, timerRedraw, windowList[i]);
		Fl::add_timeout(0.0, timerIdle, windowList[i]);
		
	}
		
}


