
#include "Camera.h"

Camera::Camera()
{
	
	projType = -1;
	
	eye[0] = 0.0;
	eye[1] = 0.0;
	eye[2] = 0.0;
	center[0] = 0.0;
	center[1] = 0.0;
	center[2] = -1.0;
	up[0] = 0.0;
	up[1] = 1.0;
	up[2] = 0.0;
	
	
}

void Camera::setProjType(int type)
{
	projType = type;
}

void Camera::ortho2D(int x, int y, int w, int h, float* offset)
{

	view[0] = w;
	view[1] = h;
	
	glViewport(0, 0, view[0], view[1]);


    glScissor(0, 0, view[0], view[1]);
	
	glMatrixMode(GL_PROJECTION);
	
	glLoadIdentity();
	
	if(projType == -1)
	{
		printf("Please define camera projection type.\n");
		exit(0);
	}
	
	if(projType == ORTHOGRAPHIC)
	{
		eye[2] = 0.0;
		glOrtho(-view[0], view[0], -view[1], view[1], -100, 100);
	}
	
	else
	{
		eye[2] = 1.0;
		gluPerspective(60, float(w)/float(h), 0.01, 100.0);
	}
	
	glTranslatef(-offset[0] * w, -offset[1] * h, 0);
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	gluLookAt(eye[0], eye[1], eye[2], center[0],
		center[1], center[2], up[0], up[1],
		up[2]);

	
}

void Camera::reshape(int x, int y, int w, int h)
{

	printf("%i %i %i %i\n", x, y, w, h);

	

}




void Camera::unproject(Point* coord, Point* p, const float M[16])
{
	GLdouble x, y, z;
	
	GLdouble projm[16];
	GLdouble mvm[16];
	GLint viewport[4];
	
	glGetIntegerv(GL_VIEWPORT, viewport);
	glGetDoublev(GL_PROJECTION_MATRIX, projm);
	
	glPushMatrix();
	
	glMultMatrixf(M);
	glGetDoublev(GL_MODELVIEW_MATRIX, mvm);
	
	glPopMatrix();
	
	x = p->get()[0] - viewport[0];
	y = viewport[3] - 1 - (p->get()[1] - viewport[1]);
	z = 0;
	
	GLdouble xyz[3];
	
	gluUnProject(x, y, z, mvm, projm, viewport, &xyz[0], &xyz[1], &xyz[2]);
	
	coord->set((float)xyz[0], (float)xyz[1]);
	
}


void Camera::project(Point* coord, Point* p)
{
	

	
}


float* Camera::getEye()
{
	return eye;
}

float* Camera::getCenter()
{
	return center;
}

float* Camera::getUp()
{
	return up;
}




