
#ifndef Camera_H
#define Camera_H


#include <stdlib.h>

#include <vector>

#include "OpenGL.h"
#include "Math.h"
#include "Basics.h"


enum PROJ_TYPE
{
	ORTHOGRAPHIC,
	PERSPECTIVE
};


class Viewport
{

	float x, y, w, h;
	
	float offset[2];

};



class Camera
{


public:

	Camera();
	

	
	void ortho2D(int, int, int, int, float*);
	void reshape(int, int, int, int);
	
	void offset(float, float);

	
	float* getEye();
	float* getCenter();
	float* getUp();
	
	
	
	void unproject(Point*, Point*, const float[16]);
	void project(Point*, Point*);
	
	
	void setProjType(int);
	
private:

	std::vector<Viewport*> viewportList;
	
	int projType;

	int view[2];
	float eye[3];
	float center[3];
	float up[3];

};


#endif

