
#include "FBO.h"



void FBO::create(int w, int h)
{

	
	
	
	glGenFramebuffersEXT(1, &fb);
	glGenRenderbuffersEXT(1, &depth_rb);
	glGenTextures(1, &tex);
	
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fb);
	glBindTexture(GL_TEXTURE_2D, tex);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, w, h, 0, GL_RGBA, GL_UNSIGNED_BYTE, NULL);
	glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, 
			GL_TEXTURE_2D, tex, 0);
	glBindRenderbufferEXT(GL_RENDERBUFFER_EXT, depth_rb);
	glRenderbufferStorageEXT(GL_RENDERBUFFER_EXT, 
			GL_DEPTH_COMPONENT24, w, h);
	glFramebufferRenderbufferEXT(GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT,
			GL_RENDERBUFFER_EXT, depth_rb);
	
	
	
	
	GLenum status;
	status = glCheckFramebufferStatusEXT(GL_FRAMEBUFFER_EXT);
	switch(status)
	{
	
		case GL_FRAMEBUFFER_COMPLETE_EXT:
			printf("Hardware supports FBO.\n");
			break;
	
		case GL_FRAMEBUFFER_UNSUPPORTED_EXT:
			printf("FBO not supported by hardware!\n");
			exit(0);
			break;
	
	}
}

void FBO::renderToFBO()
{

	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, *getFrameBuff());
	
}



void FBO::renderToWindow()
{

	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
}


GLuint* FBO::getFrameBuff()
{

	return &fb;

}

GLuint* FBO::getRendBuff()
{

	return &depth_rb;
}


GLuint* FBO::getTex()
{

	return &tex;

}

