
#ifndef Geometry_H
#define Geometry_H

#include "OpenGL.h"
#include "Basics.h"

#include <vector>

class Geometry
{

public:
	Geometry();
	Geometry(const char*, Color*, int);
	
	void set(const char*, Color*, int);
	
	const char* getName();
		
	void setVertices(std::vector<Point*>*);
	void setTCoords(std::vector<Point*>*);
		
	GLuint* getDisplayList();
	void genDisplayList();
	
	bool isReady();
	
	void setPointSize(float);
	void setLineSize(float);
	
	void setDepth(float);
	
private:
	
	float pointSize;
	float lineSize;
	
	const char* name;
	
	int geomType;
	GLuint dList;
	bool ready;

	
	Color* color;
	
	std::vector<Point*>* glVertices;
	std::vector<Point*>* glTCoords;
	float depth;
	
	
};


#endif

