

#include "Node.h"




NodeStack::NodeStack()
{


}

void NodeStack::push(int node)
{


	stack.push_front(node);
}


int NodeStack::pop()
{

	int node = stack.front();
	stack.pop_front();
	return node;
}


int NodeStack::size()
{


	return stack.size();
	
	
}






Node::Node()
{
	Matrix::load_identity(transformmat);
	
	parent = (Node*) 0;
	
	updateptr = (void (*) (Node*)) 0;
	
	name = "noname";
	
	
	alive = true;
		
}

Node::~Node()
{


}

bool Node::isAlive()
{
	return alive;
}

void Node::die()
{
	alive = false;
	
}


void Node::appendNull(int index)
{

	nullchildren.push(index);
}

void Node::translate(float x, float y, float z)
{
	float T[16];
	float M[16];
	Matrix::location(T, x, y, z);
	Matrix::do_multiply(M, glTransform(), T);
	Matrix::dump_matrix(glTransform(), M);
	
}

void Node::scale(float x, float y, float z)
{
	
	float T[16];
	float M[16];
	Matrix::scale(T, x, y, z);
	Matrix::do_multiply(M, glTransform(), T);
	Matrix::dump_matrix(glTransform(), M);

}

void Node::rotate(float x, float y, float z, float a)
{
	
	float T[16];
	float M[16];
	Matrix::rotation(T, x, y, z, a);
	Matrix::do_multiply(M, glTransform(), T);
	Matrix::dump_matrix(glTransform(), M);

}


void Node::setUpdateFunc(void (*ptr) (Node*))
{


	updateptr = ptr;

}

void Node::update() {

	if(updateptr != (void (*) (Node*)) 0)
		updateptr(this);
	else
		doupdate();
}


const char* Node::getName()
{
	return name;
	
}

void Node::setName(const char* n)
{

	name = n;
}

void Node::attachChild(Node* node)
{

	if(nullchildren.size() != 0)
	{
		int index = nullchildren.pop();
		
		children[index] = node;
		
		//printf("used existing bubble (%i) !\n", index);
	}
	else
	{

		children.push_back(node);
	}
	
	node->setParent(this);
}

void Node::setParent(Node* node)
{
	
	parent = node;

}

std::vector<Node*>* Node::getChildList()
{

	return &children;
}


Node* Node::getParent()
{
	return parent;
}

float* Node::getViewPoint()
{
	return viewpoint;
}

float* Node::glTransform()
{
	return transformmat;
}

float* Node::glWorldMatrix()
{
	return worldmat;
}


float* Node::parallelScale()
{
	return &pscale;
}




