#include "SceneGraph.h"

SceneGraph::SceneGraph()
{

	rootNode = (Node*) 0;

	
	
	
}

void SceneGraph::updateScene(Node* node)
{

	if(!node)
		return;
		
	else
	{
	
		if(node->getType() == RTTI_PARTICLE)
			pupdated++;
	
		node->update();
		
		
		
		std::vector<Node*>::iterator it =
			node->getChildList()->begin();
			
		
		for( ; it != node->getChildList()->end(); ++it )
		{
		
			updateScene((*it));
			
		}
	}	

}

void SceneGraph::drawScene(Node* node)
{

	if(!node)
		return;
		
	else
	{
	
		glPushMatrix();
		
		glMultMatrixf(node->glTransform());
		glGetFloatv(GL_MODELVIEW_MATRIX, node->glWorldMatrix());
		
		
		
		if(node->cull() == -1)
		{
			glPopMatrix();
			return;
		}
		else
		{
		
			if(node->getType() == RTTI_PARTICLE)
				pdrawn++;
		
		}
		
		std::vector<Node*>::iterator it =
			node->getChildList()->begin();
			
			
		
		int index = 0;
		for(; it != node->getChildList()->end(); ++it)
		{
		
			
			
			glPushMatrix();
			
			if((*it) && (*it)->isAlive() != true)
			{
		
			
				delete (*it);
				node->appendNull(index);
				
				(*it) = (Node*) 0;
			}
			else
			{
			
				drawScene((*it));
			}
			
			glPopMatrix();
			
			
			
			index++;
		}
		
		
		glPopMatrix();
	}	


}

void SceneGraph::setRootNode(Node* node) 
{

	rootNode = node;
}

void SceneGraph::update()
{
	pupdated = 0;
	
	if(rootNode)
	{
		updateScene(rootNode);
	}
	
	
}

void SceneGraph::draw()
{	
	pdrawn = 0;
	
		
	glMatrixMode(GL_MODELVIEW);
	
	if(rootNode)
	{
		drawScene(rootNode);
	}
	
	glFlush();
	
	

	
}




void SceneGraph::eventScene(Node* node, UserEvent* evt)
{

	if(!node)
		return;
		
	else
	{
	
		node->userEvent(evt);
		
		
		std::vector<Node*>::iterator it =
			node->getChildList()->begin();
			
		for( ; it != node->getChildList()->end(); ++it )
		{
		
			eventScene((*it), evt);
		}
	}	


}

void SceneGraph::event(UserEvent* evt)
{
	if(rootNode)
	{
		eventScene(rootNode, evt);
	}



	delete evt;
}


Node* SceneGraph::getRootNode()
{


	return rootNode;
}

void SceneGraph::setPivotNode(Node* n)
{

	pivotNode = n;
}

Node* SceneGraph::getPivotNode()
{
	return pivotNode;
}



