
#include "Shader.h"

#include <stdlib.h>
#include <stdio.h>


Shader::Shader()
{

	handle = 0;
}


void Shader::chkglErr(const char *str)
{
    static int halted = 0;
    GLenum err;
    
    /* Dump a GL error message, if any.  Report only one error. */

    if (halted == 0 && (err = glGetError()) != GL_NO_ERROR)
    {
        fprintf(stderr, "%s: %s\n", str, gluErrorString(err));
        halted = 1;
    }
}


GLhandleARB* Shader::create(const char* filename, GLenum type)
{

	
    FILE *fin;
    GLint len;
    char *buf;

    if (filename && (fin = fopen(filename, "r")))
    {
        /* Determine the file length. */

        fseek(fin, 0L, SEEK_END);
        len = (int) ftell(fin);
        fseek(fin, 0L, SEEK_SET);

        /* Allocate a text buffer and read the file to it. */

        if ((buf = (char *) malloc(len)))
        {
            GLint status;

            fread(buf, 1, len, fin);

            /* Create a shader object and compile the source. */

            handle = glCreateShaderObjectARB(type);

            glShaderSourceARB (handle, 1, (const GLcharARB **) &buf, &len);
            glCompileShaderARB(handle);

            glGetObjectParameterivARB(handle,
                                      GL_OBJECT_COMPILE_STATUS_ARB, &status);
            if (status == 0)
            {
                chkglErr("Compile");
                
            }
            free(buf);
        }
        fclose(fin);
    }
    return &handle;
	
}




GLhandleARB* Shader::getHandle()
{


	return &handle;
}

