
#include "Texture.h"


Texture::Texture(char* fname, IMAGE_TYPE fmt)
{
	imageFileName = fname;
	loaded = false;
	imageFormat = fmt;
}

BasicImage* Texture::getSource()
{
	return data;
}

void Texture::load()
{

	switch(imageFormat)
	{
	
	
		case IMAGE_JPEG:	
		{
			
			ImageJPEG *tdata = new ImageJPEG();
			if(tdata->read(imageFileName))
				printf("loaded texture data.\n");
	
	

			GLuint dList = glGenLists(1);
		
			glNewList(dList, GL_COMPILE);
		
			glGenTextures(1, &texId);
			glBindTexture(GL_TEXTURE_2D, texId);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
			glTexImage2D(GL_TEXTURE_2D, 0, tdata->getComponents(), tdata->getWidth(), 
					tdata->getHeight(), 0, GL_RGB, GL_UNSIGNED_BYTE, tdata->getPixelBuffer());
			
			glEndList();
			
			
			
			glCallList(dList);
			
	
			
		
		
	
			imageInfo[0] = tdata->getWidth();
			imageInfo[1] = tdata->getHeight();
			imageInfo[2] = tdata->getComponents();		
				
				
			data = tdata;
			
		}	
		break;
	
		case IMAGE_PNG:
		{
			ImagePNG *tdata = new ImagePNG();
			if(tdata->read(imageFileName))
				printf("loaded texture data.\n");
	
	

			GLuint dList = glGenLists(1);
		
			glNewList(dList, GL_COMPILE);
		
			glGenTextures(1, &texId);
			glBindTexture(GL_TEXTURE_2D, texId);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
			glTexImage2D(GL_TEXTURE_2D, 0, tdata->getComponents(), tdata->getWidth(), 
					tdata->getHeight(), 0, GL_RGBA, GL_UNSIGNED_BYTE, tdata->getPixelBuffer());
			
			glEndList();
			
			
			
			glCallList(dList);
			
	
			
		
		
	
			imageInfo[0] = tdata->getWidth();
			imageInfo[1] = tdata->getHeight();
			imageInfo[2] = tdata->getComponents();		
				
				
			data = tdata;
			
		}	
		break;
	}

	loaded = true;
}

int* Texture::getInfo()
{

	return imageInfo;
}

bool Texture::isLoaded()
{
	return loaded;
}

GLuint* Texture::getId()
{

	return &texId;
}



