

#ifndef Window_H
#define Window_H

#include <stdio.h>

#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>



#include "OpenGL.h"
#include "Render.h"
#include "FreeType.h"
#include "UserEvent.h"

class Window: public Fl_Gl_Window
{


 
public:

	Window(int, int, int, int, int, char*);
	
	
	
	virtual void draw();
	virtual int handle(int);
	virtual void resize(int, int, int, int);
	
	void initGL();
	void idle();
	
	int getWindowId();
	
	Render* getRender();
	
	
	void setOffset(float, float);
	
	void setFont(freetype::font_data*);
	
	void setDrawCallback(void (*) (Window*));
	
	
	int frames;
	float fps;
	   	
private:
	
	float offset[2];
   	

	float pscale;

	freetype::font_data* our_font;

	int MOUSE[2];
	
	Render render;


	int windowId;
	int height;
	int width;
	
	int origin[2];



	void (*drawcallback) (Window*);

};



#endif



