
#include "BasicImage.h"


int BasicImage::getSubImage(unsigned char* inbuf, int width,
int height, unsigned char* copy, int x, int y, int w, 
int h, int comp, float scale)
{

	if( scale == 0)
	{
		printf("Scale = 0! returning\n");
		return 0;
	}

	if( x < 0 || x >= width )
	{	
		printf("Start x not in picture bounds. pic width %d!\n", width);
		return 0;
	}
		
	if( y < 0 || y >= height )
	{
		printf("Start y not in picture bounds! pic height %d!\n", height);
		return 0;
	}

		
	int components = comp;

		
	int copyW, copyH;
	copyW = int(w * scale);
	copyH = int(h * scale);
	int skipX, skipY;
	skipX = copyW / w;
	skipY = copyH / h;


		

	memset( copy, 0, w * h * components );
		
	//copy the sub image over
	if( width < x + w )
		copyW = width - x;
	if( height < y + h )
		copyH = height - y;
		
	for( int i = 0; i < h; i++)
	{
		for( int j = 0; j < w; j++)
		{
			for( int k = 0; k < components; k++)
			{
				if( (y + (i * skipY)) < height &&
					(x + (j * skipX)) < width )
				{
					copy[ (i * w + j) * components + k] =
						inbuf[ ((y + (i * skipY)) * width +
							(x + (j * skipX))) * components + k];
				}
				else
				{
					copy[ (i * w + j) * components + k] = 0;
				}
			}	
		}
	}

	return 1;


}


