#ifndef Vector_H
#define Vector_H

#include <math.h>



class Vec3  
{

public:

	float  x,  y,  z;
	
	Vec3();
	Vec3(float x, float y, float z);
	Vec3(const Vec3& v);

	void set(float x, float y, float z);
	void copy(const Vec3 &v);
	
	float length();
	bool isnonzero();
	void normalize();
	void limit(float lim);
	void rshift(int n);
	void lshift(int n);
	void rotate(float a);

	Vec3 operator+(const Vec3 &v);
	Vec3 operator-(const Vec3 &v);
	Vec3 operator-(void);
	Vec3 operator*(float t);
	Vec3 operator/(float t);

	static float DotProduct(const Vec3& a, const Vec3& b);
	static Vec3 CrossProduct(const Vec3& a, const Vec3& b);
	static float EuclDistance(const Vec3& a, const Vec3& b);
	static float MinCompDist(const Vec3& a, const Vec3& b);
	static float AngleBetween(const Vec3& a, const Vec3& b);
	static bool Equal(const Vec3& a, const Vec3& b);
};





#endif

