
#ifndef OggSound_H
#define OggSound_H

#include <cstdio>
#include <iostream>
#include <vector>

#include "al.h"
#include "alut.h"
#include "vorbis/vorbisfile.h"



#define BUFFER_SIZE     32768       // 32 KB buffers

#define AL_SEC_OFFSET                             0x1024
#define AL_SAMPLE_OFFSET                          0x1025


class OggSound
{


public:

	OggSound();
	~OggSound();

	static void initAL(int*, char**);
	static void exitAL();

	void load(char*);
	void play();
	void loadOGG(char*, std::vector<char> &, ALenum &, ALsizei &);
	void cleanUp();
	int getState();
	
	// RATKO
	float getPlaybackOffset();    // returns how many percent of the sound file have we played so far


private:

	ALint state;                            // The state of the sound source
    ALuint bufferID;                        // The OpenAL sound buffer ID
    ALuint sourceID;                        // The OpenAL sound source
    ALenum format;                          // The sound data format
    ALsizei freq;                           // The frequency of the sound data
    std::vector<char> bufferData;           // The sound buffer data from file

	// RATKO
	ogg_int64_t numSamples;					// total number of samples in a file
	ALfloat sampleOffset;                   // The number of samples played so far
};



#endif